diff --git a/src/backend/replication/walreceiver.c b/src/backend/replication/walreceiver.c
index 8bd2ba37dd..4de0b9c387 100644
--- a/src/backend/replication/walreceiver.c
+++ b/src/backend/replication/walreceiver.c
@@ -433,6 +433,10 @@ WalReceiverMain(void)
 			for (int i = 0; i < NUM_WALRCV_WAKEUPS; ++i)
 				WalRcvComputeNextWakeup(i, now);
 
+			/* send initial reply/feedback at the next opportunity */
+			wakeup[WALRCV_WAKEUP_REPLY] = now;
+			wakeup[WALRCV_WAKEUP_HSFEEDBACK] = now;
+
 			/* Loop until end-of-streaming or error */
 			for (;;)
 			{
